Mashroom schedule
=============

schedule -- ...
-----------------------

schedule is a project for running periodical tasks and triggering notifications


How to add new task handler:
----------------------------

Add new source file into schedule.task package, define and register handler object:

```
type LandlordExtraListing struct {
}

func init() {
	initTask("landlord_extra_listing", LandlordExtraListing{}, true, "30m", nil)
}

func (handler *LandlordExtraListing) GetRequestID(ctx context.Context, data map[string]string) (string, error) {
	propertyID, ok := data["property_id"]
	if !ok || propertyID == "" {
		return "", fmt.Errorf("property ID is mandatory for this task")
	}
	return propertyID, nil
}

func (handler *LandlordExtraListing) OnEnqueue(ctx context.Context, taskEntry *model.TaskEntry, queueEntry *model.QueueEntry) error {
	log.Debugf("do something on task [%s] enqueue [%s]...", taskEntry.FullCode(), queueEntry.ID.Hex())
	return nil
}

func (handler *LandlordExtraListing) OnStop(ctx context.Context, taskInfo *model.TaskInfo) error {
	log.Debugf("do something on task [%s] stop [%s]...", taskInfo.Task.FullCode(), taskInfo.Queue[0].ID.Hex())
	return nil
}

func (handler *LandlordExtraListing) Run(ctx context.Context, taskEntry *model.TaskEntry, queueEntry *model.QueueEntry) error {
	log.Debugf("do something to process task [%s] queueEntry [%s]", taskEntry.FullCode(), queueEntry.ID.Hex())
	return nil
}

```



TODO:
-----

- Add unittests
- Read parameters from env vars
- Guard shared data with `sync.Mutex`
- Test on memory leaks
- Consider starting tasks faster than 1 task per second
