package service

import (
	"encoding/json"

	"github.com/golang/protobuf/ptypes"
	schedule "gitlab.mashroom.com/mashroom/backend/schedule/api"
	"gitlab.mashroom.com/mashroom/backend/schedule/internal/model"
)

func renderTasks(ts []*model.Task) (tasks []*schedule.Task, err error) {
	for _, t := range ts {
		task, err := renderTask(t)
		if err != nil {
			return nil, err
		}

		tasks = append(tasks, task)
	}

	return
}

func renderTask(t *model.Task) (*schedule.Task, error) {
	var data map[string]string

	err := json.Unmarshal(t.Data, &data)
	if err != nil {
		return nil, err
	}

	return &schedule.Task{
		Id:      t.ID,
		Handler: t.Handler,
		Active:  t.Active,
		Period:  ptypes.DurationProto(t.Period),
		Data:    data,
		Retry:   int32(t.Retry),
	}, nil
}
